package info.bukova.isspst;

import info.bukova.isspst.data.Role;
import info.bukova.isspst.services.Service;

import java.io.Serializable;
import java.util.List;

import org.springframework.security.access.PermissionEvaluator;
import org.springframework.security.core.Authentication;

public class IsspstPermissionEvaluator implements PermissionEvaluator {

	@SuppressWarnings("unchecked")
	@Override
	public boolean hasPermission(Authentication authentication,
			Object targetDomainObject, Object permission) {
		List<Role> perms = (List<Role>) authentication.getAuthorities();
		String moduleId = "";
		String perm = "";
		
		if (permission instanceof String) {
			perm = (String) permission;
		}
		
		if (targetDomainObject instanceof Service<?>)
		{
			for (Module m : Constants.MODULES) {
				if (m.getServiceClass().isAssignableFrom(targetDomainObject.getClass())) {
					moduleId = m.getId();
				}
			}
			
			perm += "_" + moduleId;
			
			for (Role r : perms) {
				if (r.getAuthority().equals(perm)) {
					return true;
				}
				if (r.getAuthority().equals(Constants.ROLE_ADMIN)) {
					return true;
				}
			}
		}
		
		return false;
	}

	@Override
	public boolean hasPermission(Authentication authentication,
			Serializable targetId, String targetType, Object permission) {
		return false;
	}

}
